/******************************************************************************
 * CLASSIFICATION: UNLASSIFIED//FOUO>
 *
 * Copyright(C) ProLogic, Incorporated 2008, 1000 Technology Drive, Fairmont, WV 26554
 * Produced pursuant to U.S. Government sponsorship.
 * 
 * Copyright applies to commercial uses only.   Notwithstanding the above
 * copyright/restriction, the Government possesses DFARS 252.227-7013. 
 * Unlimited Rights if this is technical data and DFARS 252.227-7014. 
 * Unlimited Rights if this is computer software or computer software 
 * documentation.
 * 
 * $Id: $
 *****************************************************************************/
/**
 * @file StringUtilsTest.cpp
 * Main header file for the PROJECT_NAME application.
 * 
 * @todo Fix file description.
 */


#include "StringUtilsTest.h"
#include "StringUtils.h"
#include <string>

using namespace std;


//forward decl
ostream& operator<<( ostream& o, const wstring& str );


static const string s_strPrintableAscii = " !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKL"
	"MNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~";

static const wstring s_strPrintableAsciiW = L" !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKL"
	L"MNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~";



void CStringUtilsTest::TestWidenning()
{
	//test that widenning a string retains the original characters

	const string& strNarrow = s_strPrintableAscii;

	//convert to wide
	wstring strWide;
	CStringUtils::Widen( strWide, strNarrow );

	//now convert back
	string strBack;
	CStringUtils::Narrow( strBack, strWide );

	//now make sure we get the same string we stared with
	CPPUNIT_ASSERT_EQUAL( strNarrow, strBack );
}



void CStringUtilsTest::TestNarrowing()
{
	//test that narrowing a string retains the original characters.
	//a little different than above in that we can't fil lthe inital wide string
	//with all printable wide characters because they don't have narrow
	//equivalents.

	const wstring& strWide = s_strPrintableAsciiW;

	//convert to narrow
	string strNarrow;
	CStringUtils::Narrow( strNarrow, strWide );

	//now convert back
	wstring strBack;
	CStringUtils::Widen( strBack, strNarrow );

	//now make sure we get the same string we stared with
	CPPUNIT_ASSERT_EQUAL( strWide, strBack );
}


